// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _HILDON_FMMM_FILE_SYSTEM_MODEL_H
#define _HILDON_FMMM_FILE_SYSTEM_MODEL_H

#include <glibmm.h>

/* $Id: date-editor.hg,v 1.10 2005/02/15 10:52:44 murrayc Exp $ */

/* grid.h
 *
 * Copyright (C) 1998-2005 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/treeiter.h>
#include <gtkmm/treemodel.h>
#include <glibmm/object.h>
// We couldn't include it in treemodel.h, but doing it here makes it easier for people.
#include <gtkmm/treepath.h>

#include <hildon-widgets/hildon-file-system-common.h>
//#include <gtk/gtkfilesystem.h> //TODO: Avoid including this, particularly as it is semi-private.

#include <hildon-widgets/hildon-file-system-model.h> //TODO: Remove this when bug #182 is fixed.


#ifndef DOXYGEN_SHOULD_SKIP_THIS
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{ class FileSystemModel_Class; } // namespace Hildon
namespace Hildon
{

/** 
 *
 * @ingroup FileSystem
 */

class FileSystemModel 
: public Glib::Object,
  public Gtk::TreeModel
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef FileSystemModel CppObjectType;
  typedef FileSystemModel_Class CppClassType;
  typedef HildonFileSystemModel BaseObjectType;
  typedef HildonFileSystemModelClass BaseClassType;

private:  friend class FileSystemModel_Class;
  static CppClassType filesystemmodel_class_;

private:
  // noncopyable
  FileSystemModel(const FileSystemModel&);
  FileSystemModel& operator=(const FileSystemModel&);

protected:
  explicit FileSystemModel(const Glib::ConstructParams& construct_params);
  explicit FileSystemModel(HildonFileSystemModel* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~FileSystemModel();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  HildonFileSystemModel*       gobj()       { return reinterpret_cast<HildonFileSystemModel*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const HildonFileSystemModel* gobj() const { return reinterpret_cast<HildonFileSystemModel*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  HildonFileSystemModel* gobj_copy();

private:

  
public:
  FileSystemModel();
   //TODO: Remove this when bug #182 is fixed.

  Gtk::TreeModel::iterator search_local_path(const Glib::ustring& path, bool recursive = true) const;
  Gtk::TreeModel::iterator search_local_path(const Glib::ustring& path, const Gtk::TreeModel::iterator& start_iter, bool recursive = true) const; ;

  Gtk::TreeModel::iterator search_uri(const Glib::ustring& uri, bool recursive = true) const;
  Gtk::TreeModel::iterator search_uri(const Glib::ustring& uri, const Gtk::TreeModel::iterator& start_iter, bool recursive = true) const;
  

  Gtk::TreeModel::iterator search_path(const GtkFilePath* path, bool recursive = true) const;
  Gtk::TreeModel::iterator search_path(const GtkFilePath* path, const Gtk::TreeModel::iterator& start_iter, bool recursive = true) const;
  

  Gtk::TreeModel::iterator load_local_path(const Glib::ustring& path);
  

  Gtk::TreeModel::iterator load_uri(const Glib::ustring& uri);
  

  Gtk::TreeModel::iterator load_path(const GtkFilePath* path);
  

  /** Creates a new unique name under #parent. The returned name can be used
   * when creating a new file. If there are no name collisions, stub name
   * will be the final name. If a file with that name already exists, then
   * a number is appended to stub. This function is mainly used by dialog
   * implementations. It's probably not needed in application development.
   * @param parent A parent iterator.
   * @param stub_name A boby of the new name.
   * @param extension Extension of the new name.
   * @return A New unique name. You have to release this with #g_free. Can be <tt>0</tt>, if
   * the directory is not yet loaded.
   */
  Glib::ustring new_item(const Gtk::TreeModel::iterator& parent, const Glib::ustring& stub_name, const Glib::ustring& extension);

  
  /** This function checks if the given URI already exists in the model.
   * if not, then a copy of it is returned unmodified. If the URI already
   * exists then a number is added in a form file://file(2).html.
   * @param uri An URI to be autonamed.
   * @param error A GError to hold possible error information.
   * @return Either the same uri given as parameter or a modified
   * uri that contains proper index number. In both cases free
   * this value using #g_free. Value can be <tt>0</tt>, if error was
   * encountered.
   */
  Glib::ustring autoname_uri(const Glib::ustring& uri);

//TODO: output?
  
  /** This function sets some paths available/not available. Locations
   * that are not available are usually shown dimmed in the gui. This
   * function can be used if program needs for some reason to disable some
   * locations. By default all paths are available.
   * @param iter A Gtk::TreeIter to location to modify.
   * @param available New availability state.
   */
  void iter_available(const Gtk::TreeModel::iterator& iter, bool available);

  
  /** Cancels all changes made by #hildon_file_system_model_iter_available.
   * Selection is back to it's default state.
   */
  void reset_available();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Hildon


namespace Glib
{
  /** @relates Hildon::FileSystemModel
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Glib::RefPtr<Hildon::FileSystemModel> wrap(HildonFileSystemModel* object, bool take_copy = false);
}


#endif /* _HILDON_FMMM_FILE_SYSTEM_MODEL_H */

